//========================================================
//Universe.cpp
//========================================================
//  This is the main code which implements the member
// functions of both classes declared in Universe.h

#define BUILDING_UNIVERSE_H 1

#include <Message.h>
#include <Archivable.h>
#include <File.h>
#include <iostream.h>
#include "Universe.h"

//=========================================================

Universe::Universe()
  :aggregatef()
{
};

primitivef *findstars(BMessage *msg_archive)
{
  const char *typestr;
  msg_archive->FindString("GType", &typestr);
  
  if (strcmp(typestr,"STAR") == 0)
    return (primitivef *) System::Instantiate(msg_archive);
  else
    return NULL;
};

Universe::Universe(BMessage *msg_archive)
  :aggregatef(msg_archive, &findstars)
{
};

status_t Universe::Archive(BMessage *msg_archive, bool deep) const
{
  aggregatef::Archive(msg_archive, deep);
    msg_archive->AddString("class","Universe");
  return B_OK;  
};

BArchivable *Universe::Instantiate(BMessage *msg_archive)
{
  if (msg_archive->what == 'UNVS')
    return new Universe(msg_archive);
  else
    return NULL;
};

void Universe::Save(BFile *file_Save)
{
  BMessage *msg_thisuniverse = new BMessage('UNVS');
  Archive(msg_thisuniverse, true);
  msg_thisuniverse->Flatten(file_Save);
  delete msg_thisuniverse;
};

Universe *Universe::Open(BFile *file_Open)
{
  BMessage * msg_newuniverse; status_t err_open;
  msg_newuniverse = new BMessage('OPEN');
  err_open = msg_newuniverse->Unflatten(file_Open);
  
  if (err_open == B_OK)
    {
      Universe *temp;
      temp = (Universe *)Universe::Instantiate(msg_newuniverse);
      return temp;
    }
  else
    return NULL;   
};